SystemOrganization addCategory: #'Spec-Examples-PolyWidgets'!
SystemOrganization addCategory: #'Spec-Examples-Widgets'!

ComposableModel subclass: #CheckBoxExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!CheckBoxExample commentStamp: '<historical>' prior: 0!
A CheckBoxExample is a simple example of how to use CheckBoxes.

CheckBoxExample new openWithSpec!

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 11:42'!
defaultSpec

	^ { #ComposableSpec.
			#add:.	{ self topSpec. #layout:. 	#(FrameLayout
													bottomFraction: 0
													bottomOffset: 20) }.
			#add:.	{{#model . #container } . #layout: . #(FrameLayout topOffset: 22) }
	   }! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:27'!
defaultSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.}.
			#addMorph:. {#model.	#button2.}.
			#addMorph:. {#model.	#button3.}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 17:17'!
title

	^ 'CheckBox Example'! !

!CheckBoxExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 11:46'!
topSpec

	^ { #ComposableSpec.
			#add:. {{#model .	#button1 } . #layout:.  #(FrameLayout
															rightFraction: 0.33
															bottomFraction: 0
															bottomOffset: 25)}.
			#add:.  {{#model .	#button2 } . #layout:. #(FrameLayout
															leftFraction: 0.33
															rightFraction: 0.66
															bottomFraction: 0
															bottomOffset: 25)}.
			#add:.  {{#model .	#button3 } . #layout:. #(FrameLayout
															leftFraction: 0.66
															bottomFraction: 0
															bottomOffset: 25)}}! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button1

	^ button1! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button2

	^ button2! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
button3

	^ button3! !

!CheckBoxExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
container

	^ container! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:23'!
initialize
	"Initialization code for RadioButtonGroupExample"

	container := PanelMorph new.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.
	super initialize.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:23'!
initializePresenter

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:23'!
initializeWidgets 

	self instantiateModels: #(
		button1 CheckBoxModel
		button2 CheckBoxModel
		button3 CheckBoxModel ).
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.
	self setFocus.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!CheckBoxExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:01'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #ClassMethodBrowser
	instanceVariableNames: 'listModel methodModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!ClassMethodBrowser commentStamp: '<historical>' prior: 0!
A ClassMethodBrowser is a simple browser using spec and reusing MethodBrowser to browse classes>>methods>>sourceCode.
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.!

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/22/2012 19:19'!
defaultSpec
<spec>
	^ SpecLayout composed
		newRow: [:row | row
						add: #listModel;
						add: #methodModel ];
		yourself! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 14:16'!
defaultSpec2
<spec: #default>
	^ { #ComposableSpec.
			#add:. {{#model. #listModel.}.
											#layout:. #(FrameLayout
																	rightFraction: 0.5
																	bottomFraction: 0.5)}.
			#add:. {{#model. #methodModel. #listModel.}.
											#layout:.#(FrameLayout
																	leftFraction: 0.5
																	bottomFraction: 0.5)}.
			#add:. {{#model. #methodModel. #textModel}.
											#layout:.#(FrameLayout
																	topFraction: 0.5)}}.! !

!ClassMethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 2/2/2012 13:39'!
example

	"self example"
	| cb |
	cb := ClassMethodBrowser new.
	cb openWithSpec.
	cb classes: Smalltalk allClasses.! !

!ClassMethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/14/2011 18:12'!
title

	^ 'Class Method Browser'! !

!ClassMethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/22/2012 19:16'!
classes: aList

	self listModel items: aList! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/6/2012 20:46'!
initialize
	"Initialization code for ClassMethodBrowser"

	super initialize.

	listModel := self instantiate: ListComposableModel.
	methodModel := self instantiate: MethodBrowser.
	
	self focusOrder
		add: listModel;
		add: methodModel.
	
	listModel whenSelectedItemChanged: [:selection |
		selection 
			ifNotNil: [:class | 
				methodModel methods: (class methodDict values sort: [:a :b | a selector < b selector]).
				methodModel listModel resetSelection ]].
	
	methodModel wrapWith: [:method | method selector ].! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:34'!
initializePresenter
	
	listModel whenSelectedItemChanged: [:selection |
		selection 
			ifNotNil: [:class | 
				methodModel methods: (class methodDict values sort: [:a :b | a selector < b selector]).
				methodModel listModel resetSelection ]].! !

!ClassMethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:34'!
initializeWidgets

	self instantiateModels: #(
		listModel ListComposableModel
		methodModel MethodBrowser ).
	
	self focusOrder
		add: listModel;
		add: methodModel.
	
	methodModel displayBlock: [:method | method selector ].! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
listModel

	^ listModel! !

!ClassMethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 18:03'!
methodModel

	^ methodModel! !

ComposableModel subclass: #DropListExample
	instanceVariableNames: 'dropList container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!DropListExample commentStamp: '<historical>' prior: 0!
A DropListExample is a simple example of how to use drop lists.

DropListExample new openWithSpec!

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 13:30'!
defaultSpec

	^ { #ComposableSpec.
			#add:.	{ self topSpec . #layout: . #(FrameLayout
													bottomFraction: 0
													bottomOffset: 30) }.
			#add:.	{{#model . #container } . #layout: .  #(FrameLayout
													topOffset: 42). }}! !

!DropListExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/5/2012 17:17'!
title

	^ 'Drop list'! !

!DropListExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:19'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#dropList.}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#shrinkWrap.	}! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
blueMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph2 ]! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
container

	^ container! !

!DropListExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 15:36'!
dropList

	^ dropList! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
greenMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph3 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:25'!
initialize
	"Initialization code for RadioButtonGroupExample"

	container := PanelMorph new.
	self instantiateMorphs.
	
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	super initialize.! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:25'!
initializeWidgets 

	| item1 item2 item3 |

	self instantiateModels: #(dropList #DropListModel).
	
	item1 := DropListItem named: 'Red morph' do: self redMorphBlock.
	item2 := DropListItem named: 'Blue morph' do: self blueMorphBlock.
	item3 := DropListItem named: 'Green morph' do: self greenMorphBlock.
	
	dropList items: {item1. item2. item3}.
	self setFocus.! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:20'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!DropListExample methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 2/2/2012 15:38'!
redMorphBlock

	^ [ 	container removeAllMorphs.
		container addMorph: morph1 ]! !

!DropListExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 15:26'!
setFocus
	
	self focusOrder
		add: dropList;
		add: container.
	! !

ComposableModel subclass: #ListSelectionModel
	instanceVariableNames: 'listModel textModel1 textModel2 textRefreshingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!ListSelectionModel commentStamp: '<historical>' prior: 0!
A ListSelectionModel is a basic example to show multi selection on lists

| l |
l := ListSelectionModel new.
l openWithSpec!

!ListSelectionModel class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:19'!
bottomSpec

	^ {#Panel.
			#changeTableLayout.
			#listDirection:.			#rightToLeft.
			#addMorph:.			{#model.	#textModel1.}.
			#addMorph:.			{#model.	#textModel2.}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#spaceFill.}! !

!ListSelectionModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 14:15'!
defaultSpec

	^{#ComposableSpec.	
			#add:.			{{	#model.	#listModel.}.
									#layout:. {#(FrameLayout
													bottomFraction: 0.5).}}.
			#add:.			{{	#model.	#textModel1.}.
									#layout:. {#(FrameLayout
													topFraction: 0.5
													rightFraction: 0.5). }}.
			#add:.			{{	#model.	#textModel2.}.
									#layout:. {#(FrameLayout
													leftFraction: 0.5
													topFraction: 0.5) }}}.! !

!ListSelectionModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:27'!
initializePresenter 

	listModel whenSelectionChanged: [ self updateText ]! !

!ListSelectionModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:27'!
initializeWidgets

	self instantiateModels: #(
		listModel ListComposableModel
		textModel1 TextModel
		textModel2 TextModel ).
	
	listModel beMultipleSelection.
	
	listModel items: Smalltalk allClasses.! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:06'!
listModel

	^ listModel! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:07'!
textModel1

	^ textModel1! !

!ListSelectionModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/9/2012 17:07'!
textModel2

	^ textModel2! !

!ListSelectionModel methodsFor: 'update' stamp: 'BenjaminVanRyseghem 2/9/2012 18:07'!
updateText
	"update the displayed list in a separate thread to avoid UI blocking"
	
	"if there is already a background thread running for the new list discard it"
	textRefreshingProcess ifNotNil: [
		textRefreshingProcess terminate].
	
	"fork off a possibly costly list calculation"
	textRefreshingProcess := [
		| indexes items |
		indexes := listModel selectedIndexes sort collect: [:i | i printString ].
		indexes :=  (indexes joinUsing: '; ').
		items := listModel selectedItems collect: [:i | i printString ].
		items := (items sort joinUsing: '; ').
		WorldState addDeferredUIMessage: [
			textModel1 text: indexes.
			textModel2 text: items]] fork.! !

ComposableModel subclass: #MethodBrowser
	instanceVariableNames: 'listModel textModel toolbarModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!MethodBrowser commentStamp: '<historical>' prior: 0!
A MethodBrowser is a simple browser using Spec to display a list of methods and their source code

	si := MethodBrowser new.
	si openWithSpec.
	si methods: Object methodDict values!

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/15/2013 13:48'!
defaultSpec

	^{ #ComposableSpec.
			#add:. {{#model. #listModel}. #layout:.  #(FrameLayout
															bottomFraction: 0.5
															bottomOffset: -15) }.
			#add:. {{#model. #toolbarModel}. #layout:.  #(FrameLayout
															topFraction: 0.5
															bottomFraction: 0.5
															topOffset: -15
															bottomOffset: 15) }.															
			#add:. {{#model. #textModel}. #layout:. #(FrameLayout
															topFraction: 0.5
															topOffset: 15). }}! !

!MethodBrowser class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:27'!
defaultSpec2
^{ #Panel.
		#changeTableLayout.
		#listDirection:. 	#bottomToTop.
		#addMorph:. 		{#model. #listModel.}.
		#addMorph:. 		{#model. #textModel.}.
		#vResizing:.		 #spaceFill.
		#hResizing:.		 #spaceFill.}! !

!MethodBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 1/16/2012 23:18'!
example

	| mb |
	mb := MethodBrowser new.
	mb openWithSpec.
	mb methods: Object methodDict values! !

!MethodBrowser class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/31/2012 13:36'!
title

	^ 'Method Browser'! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/12/2012 19:35'!
acceptBlock: aBlock

	textModel acceptBlock: aBlock! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:42'!
action

	^ textModel actionToPerformHolder content! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/12/2012 19:32'!
displayBlock: aBlock

	listModel displayBlock: aBlock! !

!MethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:33'!
initializePresenter

	listModel whenSelectedItemChanged: [:selection |
		selection
			ifNil: [
				textModel text: ''.
				textModel behavior: nil.
				toolbarModel method: nil ]
			ifNotNil: [:m | 
				textModel text: m sourceCode.
				textModel behavior: m methodClass.
				toolbarModel method: m ]].
	
	self acceptBlock: [:t | self listModel selectedItem inspect ].
	self wrapWith: [:item | item methodClass name,'>>#', item selector ].! !

!MethodBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:33'!
initializeWidgets

	self instantiateModels: #(
		listModel ListComposableModel
		textModel TextModel
		toolbarModel MethodToolbar ).
	
	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel.
	
	textModel aboutToStyle: true.! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
listModel

	^ listModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/31/2012 13:10'!
methods: aList

	"Here I reroute my entry point to the list model's entry point"
	self listModel items: aList! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/13/2012 16:24'!
sortingBlock: aBlock 

	listModel sortingBlock: aBlock ! !

!MethodBrowser methodsFor: 'focus' stamp: 'BenjaminVanRyseghem 1/17/2012 03:16'!
takeKeyboardFocus

	^ self listModel takeKeyboardFocus! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/14/2011 14:51'!
textModel

	^ textModel! !

!MethodBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/18/2012 01:58'!
toolbarModel

	^ toolbarModel! !

!MethodBrowser methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 6/6/2012 20:46'!
wrapWith: aBlock

	listModel displayBlock: aBlock! !

ComposableModel subclass: #RadioButtonGroupExample
	instanceVariableNames: 'button1 button2 button3 container morph1 morph2 morph3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!RadioButtonGroupExample commentStamp: '<historical>' prior: 0!
A RadioButtonGroupExample is an simple example about how to use RadioButtons and RadioGroup!

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'StephaneDucasse 12/21/2012 18:59'!
defaultSpec

	^ { #Panel.
			#changeProportionalLayout.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		self topSpec.
											#fullFrame:. 	#(0 0 1 0 0 0  0 20) }.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:. 		{#model. #container.}.
											#fullFrame:.	#(0 0 1 1 0 22 0 0) }.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:27'!
defaultSpec2

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.}.
			#addMorph:. {#model.	#button2.}.
			#addMorph:. {#model.	#button3.}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/1/2012 17:51'!
title

	^ 'Radio Button Group Example'! !

!RadioButtonGroupExample class methodsFor: 'specs' stamp: 'bvr 6/4/2012 17:21'!
topSpec

	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#button1.}.
			#addMorph:. {#model.	#button2.}.
			#addMorph:. {#model.	#button3.}.
			#hResizing:.	#shrinkWrap.
			#vResizing:.	#shrinkWrap.	}! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button1

	^ button1! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button2

	^ button2! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/1/2012 17:52'!
button3

	^ button3! !

!RadioButtonGroupExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/2/2012 00:39'!
container

	^ container! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:30'!
initialize
	"Initialization code for RadioButtonGroupExample"

	super initialize.

	container := PanelMorph new.
	container
		changeTableLayout;
		listDirection: #bottomToLeft.
	
	self instantiateMorphs.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:29'!
initializePresenter

	self setActions.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:29'!
initializeWidgets
	"Initialization code for RadioButtonGroupExample"

	self instantiateModels: #(
		button1 RadioButtonModel
		button2 RadioButtonModel
		button3 RadioButtonModel ).
	
	button1 label: 'Button 1'.
	button2 label: 'Button 2'.
	button3 label: 'Button 3'.
	
	self setFocus.
	self setGroup.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:29'!
instantiateButtons

	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 01:00'!
instantiateMorphs

	morph1 := Morph new
					color: Color red;
					width: 60;
					height: 20.
	morph2 := Morph new
					color: Color blue;
					width: 20;
					height: 60.
	morph3 := Morph new
					color: Color green;
					width: 50;
					height: 50.! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:50'!
setActions

	self setActionsForButton1.
	self setActionsForButton2.
	self setActionsForButton3.	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton1

	button1 whenActivatedDo: [ container addMorph: morph1 ].
	button1 whenDesactivatedDo: [ container removeMorph: morph1 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton2

	button2 whenActivatedDo: [ container addMorph: morph2 ].
	button2 whenDesactivatedDo: [ container removeMorph: morph2 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:56'!
setActionsForButton3

	button3 whenActivatedDo: [ container addMorph: morph3 ].
	button3 whenDesactivatedDo: [ container removeMorph: morph3 ]! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:47'!
setFocus
	
	self focusOrder
		add: button1;
		add: button2;
		add: button3.
	! !

!RadioButtonGroupExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 2/2/2012 00:49'!
setGroup

	RadioButtonGroup new 
		addRadioButton: button1;
		addRadioButton: button2;
		addRadioButton: button3;
		default: button1.
	! !

ComposableModel subclass: #TextFieldExample
	instanceVariableNames: 'methodBrowser textField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-Widgets'!

!TextFieldExample commentStamp: '<historical>' prior: 0!
A TextFieldExample is a simple example of how to use TextFields.!

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 6/13/2012 16:22'!
defaultSpec
	| textFieldHeight |
	
	textFieldHeight := StandardFonts defaultFont height + 15.
	^ SpecLayout composed
	 	add: #textField origin: 0@0 corner: 1@0 offsetOrigin: 0@0 offsetCorner: 0@textFieldHeight;
	 	add: #methodBrowser origin: 0@0 corner: 1@1 offsetOrigin: 0@textFieldHeight offsetCorner: 0@textFieldHeight;
		yourself ! !

!TextFieldExample class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
title

	^ 'Text Field Example'! !

!TextFieldExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/12/2012 19:31'!
initializePresenter
	
	textField acceptBlock: [:text | Smalltalk globals at: text asSymbol
								ifPresent: [:class | methodBrowser methods: class methodDict values ]
								ifAbsent: [ methodBrowser methods: {} ]]! !

!TextFieldExample methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 6/13/2012 16:23'!
initializeWidgets

	self instantiateModels: #(
		methodBrowser MethodBrowser
		textField TextInputFieldModel ).
	
	textField 
		ghostText: 'Enter a class name';
		autoAccept: true;
		removeEntryCompletion.
	methodBrowser 
		sortingBlock: [:a :b | a selector < b selector ];
		displayBlock: [:m | m selector ]! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
methodBrowser

	^ methodBrowser! !

!TextFieldExample methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 2/4/2012 14:41'!
textField

	^ textField! !

PanelMorph subclass: #TabContainerMorph
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!TabContainerMorph commentStamp: '<historical>' prior: 0!
A TabContainerMorph is a morph (which should be pluggable soon) which handle a first bar for tabs button and a container which is used to display the morph corresponding to the selected tab!

!TabContainerMorph class methodsFor: 'example' stamp: 'bvr 6/4/2012 17:26'!
example

	| tc testMorph model model2 model3 anotherMorph anotherMorph2 associations classes |
	
	model := ClassMethodBrowser new.
	model2 := ClassMethodBrowser new.
	model3 := ClassMethodBrowser new.
	
	testMorph := model buildWithSpec.
	anotherMorph := model2 buildWithSpec.
	anotherMorph2 := model3 buildWithSpec.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph. 'Again' -> anotherMorph2}.
	tc := self withTabs: associations.
	classes := Smalltalk allClasses.
	model classes: classes .
	model2 classes: classes.
	model3 classes: classes.
	
	( tc embeddedInMorphicWindowLabeled: 'test') openInWorld.
	^ tc! !

!TabContainerMorph class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/7/2012 06:04'!
withTabs: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabContainerMorph methodsFor: 'private' stamp: 'IgorStasenko 12/19/2012 18:07'!
addAll
	
	self
		addMorph: tab
		fullFrame: ((0 @ 0 corner: 1 @ 0) asLayoutFrame bottomOffset: 35).
				
	self
		addMorph: container
		fullFrame: (LayoutFrame identity topOffset: 35)! !

!TabContainerMorph methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 1/7/2012 06:02'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ self setContent: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
container

	^ container! !

!TabContainerMorph methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/7/2012 06:14'!
initialize
	"Initialization code for TabContainerMorph"

	super initialize.
	
	self changeProportionalLayout.
	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	
	tab := PluggableTabBarMorph on: self.
	tab width: 150.
	tab color: Color white darker darker.
	
	self addAll.! !

!TabContainerMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/9/2012 18:43'!
setContent: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabContainerMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/7/2012 06:08'!
tab

	^ tab! !

Object subclass: #TabClassical
	instanceVariableNames: 'container tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Examples-PolyWidgets'!

!TabClassical commentStamp: '<historical>' prior: 0!
A TabClassical is an example to learn how to use tabs ;)!

!TabClassical class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/5/2012 18:33'!
associations: associations

	^ self new
		addTabs: associations;
		yourself.! !

!TabClassical class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 6/22/2012 19:18'!
example

	| tc testMorph model anotherMorph associations |
	
	model := ClassMethodBrowser new.
	
	testMorph := model buildWithSpec: #defaultSpec.
	anotherMorph := model buildWithSpec: #defaultSpec2.
	
	associations := {'Test' -> testMorph. 'Another'-> anotherMorph}.
	tc := self associations: associations.
	
	model classes: (Smalltalk allClasses).
	tc open.! !

!TabClassical methodsFor: 'display' stamp: 'IgorStasenko 12/20/2012 14:13'!
addAll: window
	
	window
		addMorph: tab
		fullFrame: ((0 @ 0 corner: 1 @ 0) asLayoutFrame bottomOffset: 35).
				
	window
		addMorph: container
		fullFrame: (LayoutFrame identity topOffset: 35).
				
	tab tabs size = 0 ifTrue: [ ^ self ].
	tab color: Color white darker darker! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/15/2012 22:13'!
addTabs: associations

	associations do: [:each |
		self tab 
			addTab: (Text fromString: each key) 
			withAction: [ 	self setMorph: each value ].
		container submorphs isEmpty ifTrue: [ container addMorph: each value ]]! !

!TabClassical methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/5/2012 18:30'!
initialize
	"Initialization code for TabClassical"

	super initialize.

	container := PanelMorph new changeTableLayout; listDirection: #bottomToTop; color: Color white; yourself.
	tab := PluggableTabBarMorph on: self.
	tab width: 150.! !

!TabClassical methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/5/2012 18:21'!
open

	| window panel |
	window := StandardWindow new.
	panel := PanelMorph new hResizing: #spaceFill; vResizing: #spaceFill; changeProportionalLayout.

	window addMorph: panel frame: (0@0 corner: 1@1).
	self addAll: panel.
	window openInWorld.
	
	window title: 'Tab Test'! !

!TabClassical methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/3/2012 18:59'!
setMorph: aMorph

	container removeAllMorphs.
	container addMorph: aMorph.
	aMorph color: Color white.
	aMorph takeKeyboardFocus.! !

!TabClassical methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/3/2012 19:02'!
tab

	^ tab! !
